BINDING_NAME_MRHAT_TOGGLE = "Toggle helmet";
BINDING_HEADER_MRHAT_TITLE = "MrHat";
local options = { 
    type='group',
    args = {
        mode = {
		type = 'text',
		name = 'mode',
		desc = "Set the mode",
		get = "GetMode",
		set = "SetMode",
		validate = { ["OFF"] = "Off", ["ON"] = "On", ["AUTO"] = "Auto" }
        },
    },
}



MrHat = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "FuBarPlugin-2.0")
MrHat:RegisterChatCommand({"/mrhat"}, options)

local files = {
	hat = "Interface\\AddOns\\MrHat\\hat.tga",
}


MrHat.hasIcon = files.hat
MrHat.defaultPosition = "RIGHT"
MrHat.cannotDetachTooltip = TRUE


MrHat:RegisterDB("MrHatDB", "MrHatDBPC")
MrHat:RegisterDefaults("profile", {
    mode = "AUTO"
} )
MrHat.OnMenuRequest = {
    type='group',
    args = {
        mode = {
		type = 'text',
		name = 'mode',
		desc = "Set the mode",
		get = "GetMode",
		set = "SetMode",
		validate = { ["OFF"] = "Off", ["ON"] = "On", ["AUTO"] = "Auto" }
        }
    }
}

function MrHat:OnEnable()
    self:RegisterEvent("PLAYER_REGEN_DISABLED")
    self:RegisterEvent("PLAYER_REGEN_ENABLED")
    self:RegisterEvent("PLAYER_ENTER_COMBAT")
    self:RegisterEvent("PLAYER_LEAVE_COMBAT")
    self:RegisterEvent("PLAYER_LEAVING_WORLD")
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    self:UpdateText()
end

function MrHat:Toggle()
	if (MrHat:GetMode() == "OFF") then 
		MrHat:SetMode("ON")
		self:Print("MrHat: Mode is now set to [ON]")
	elseif (MrHat:GetMode() == "ON") then 
		MrHat:SetMode("AUTO")
		self:Print("MrHat: Mode is now set to [AUTO]")
	elseif(MrHat:GetMode() == "AUTO") then 
		MrHat:SetMode("OFF")
		self:Print("CombHat: Mode is now set to [OFF]")
	end
	--MrHat:Update()
end

function MrHat:GetMode()
    return self.db.profile.mode
end

function MrHat:SetMode(newValue)
    self.db.profile.mode = newValue
    MrHat:Update()
end

function MrHat:ShowHat()
	ShowHelm(1)
end

function MrHat:HideHat()
	ShowHelm(0)
end

function MrHat:Update()
	if (self.db.profile.mode == "ON") then
		MrHat:ShowHat()
	elseif (self.db.profile.mode == "OFF") then
		MrHat:HideHat()
	elseif (self.db.profile.mode == "AUTO") then
		if (UnitAffectingCombat("player") == nil) then
			MrHat:HideHat()
		else
			MrHat:ShowHat()
		end
	end
	MrHat:UpdateText()
end

function MrHat:PLAYER_REGEN_DISABLED()
	if (self.db.profile.mode == "AUTO") then
		MrHat:ShowHat()
	end
end

function MrHat:PLAYER_REGEN_ENABLED()
	if (self.db.profile.mode == "AUTO") then
		MrHat:HideHat()
	end
end

function MrHat:PLAYER_ENTER_COMBAT()
	if (self.db.profile.mode == "AUTO") then
		MrHat:ShowHat()
	end
end

function MrHat:PLAYER_LEAVE_COMBAT()
	if (self.db.profile.mode == "AUTO") then
		if (UnitAffectingCombat("player") == nil) then
			MrHat:HideHat()
		end
	end
end

function MrHat:PLAYER_ENTERING_WORLD()
	if (self.db.profile.mode == "AUTO") then
		if (UnitAffectingCombat("player") == nil) then
			MrHat:HideHat()
		end
	end
end

function MrHat:PLAYER_LEAVING_WORLD()
	if (self.db.profile.mode == "AUTO") then
		if (UnitAffectingCombat("player") == nil) then
			MrHat:HideHat()
		end
	end
end

function MrHat:UpdateText()
    self:SetText((self.db.profile.mode == "AUTO") and "Auto" or (self.db.profile.mode == "OFF") and "Off" or (self.db.profile.mode == "ON") and "On")
end

local tablet = AceLibrary("Tablet-2.0")
function MrHat:OnTooltipUpdate()
	--self:write("hepp")
    local modeStr = (self.db.profile.mode == "AUTO") and "Auto" or (self.db.profile.mode == "OFF") and "Off" or (self.db.profile.mode == "ON") and "On" 
    local descStr = (self.db.profile.mode == "AUTO") and "Your hat will automatically be turned visible in combat" or (self.db.profile.mode == "OFF") and "Your hat will always be invisible" or (self.db.profile.mode == "Your hat will always be visible") and "On" 

	local cat =tablet:AddCategory()
		cat:AddLine(
			"text", "Mode: " .. modeStr
		)
		cat:AddLine(
			"text", descStr
		)
    local flag = false
	local unflag = true
    tablet:SetHint(flag and "Click to do toggle mode." or unflag and "no text")
end
	
function MrHat:OnClick()
	self:Toggle()
end
